Page MenuHomePhabricator

Undeploy the GettingStarted extension
Closed, ResolvedPublicThu, Oct 7

Description

From the description of the Newcomer Tasks project (see T227728: [EPIC] Growth: Newcomer tasks 1.0) and the initial implementation of the underlying API (see T234426: Newcomer tasks: GrowthExperiments API for template tasks), it appears that the project supersedes the GettingStarted project.

The GettingStarted project was deployed by the old Growth Team in 2013 (?) and active development ceased circa August 2014. Because the team disbanded quickly, however, and the project was never undeployed. Newly registered users still receive the GettingStarted UX to this day.

It's great that an extension not under active development still impacts people's experiences on the Wikipedias and largely a testament to the contributors who have fixed compatibility issues and/or bugs after the extension's authors moved on. Simultaneously, all deployed code is a maintenance burden and the GettingStarted project is no exception. We should discuss whether the Newcomer Tasks project does indeed supersede GettingStarted and whether the latter can be undeployed.

Additional places to undeploy/update references:

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

I'm not aware of any community liking GettingStarted. I heard some tutors saying it is a disturbance when they host a workshop.

My thoughts haven't changed since I wrote T235752#5591788. We should move on and start the depreciation process:

  1. announcing in Tech News, with an end date and reasons why,
  2. consider the feedback received (we have to define a place)
    • possibly, guide people who actually use GettingStarted for onboarding to move to Growth tools
  3. remove the extension.

A separate task regarding this community relations aspect will be needed.

@Urbanecm_WMF -- could you create the definitive list of the wikis on which GettingStarted is active? I know that @kostajh made this list earlier in the task, but on some wikis in the list when I create an account (e.g. enwiki), GettingStarted appears, while on other wikis in the list (e.g. frwiki) it does not. Could you help us understand what's going on with that?

The list by Kosta is still accurate. frwiki doesn't have any tasks, so no gettingstarted appears (unless you create an account while being on a certain page).

List of wikis with tasks configured:

[urbanecm@mwmaint1002 ~/Documents/gettingstarted]$ while read wiki; do echo 'echo $wgGettingStartedCategoriesForTaskTypes["copyedit"];' | mwscript eval.php --wiki=$wiki | sed "2d;s/^/$wiki    /g"; done < wikis.txt  > res                     
[urbanecm@mwmaint1002 ~/Documents/gettingstarted]$ grep -v 'wiki        $' res | cut -f 1
cawiki
enwiki
eswiki
ptwiki
simplewiki
svwiki
ukwiki
zhwiki
[urbanecm@mwmaint1002 ~/Documents/gettingstarted]$

All wikis with GettingStarted installed:

[urbanecm@mwmaint1002 ~/Documents/gettingstarted]$ cat wikis.txt
testwiki
test2wiki
astwiki
bswiki
cawiki
dawiki
dewiki
elwiki
enwiki
eswiki
fawiki
frwiki
fowiki
glwiki
hewiki
huwiki
iswiki
itwiki
jawiki
kowiki
lbwiki
mkwiki
mlwiki
nlwiki
plwiki
ptwiki
ruwiki
simplewiki
svwiki
viwiki
ukwiki
zhwiki
[urbanecm@mwmaint1002 ~/Documents/gettingstarted]$

It also looks WelcomeSurvey manages to (at least sometimes) suppress GettingStarted.

Does this help, @MMiller_WMF?

announcing in Tech News, with an end date and reasons why,

@MMiller_WMF does the overall plan sound good? I guess this is the most timely, and the sooner we do this the better.

Thanks for bringing this back up, @Jdlrobson.

@Trizek-WMF -- now that the Growth features are spreading to almost every Wikipedia, I think we are definitely in good shape to be turning off GettingStarted and removing it -- because the Growth features supersede it, doing what it was meant to do and more. I think that should be an important part of our explanation of why this change is happening. All the wikis that have tasks configured for getting started per T235752#7145639 also have Growth features now (except zhwiki and enwiki -- but enwiki is on the way). When we proceed with the announcement, that will help us detect if any communities will be concerned?

Growth features are the reason why we remove this extension from the wikis, as long as the fact it is not actively developed. The two wikis we have will soon get Growth features:

  • en.wp already have them but as a trial, and we want to avoid any conflict between GettingStarted and Growth interactions,
  • zh.wp has Growth features in dark mode, and is read to get them as a default experience; we are waiting for some extra analysis from the Editing team there.

I don't expect any particular reactions, since it is a feature that only targets newcomers.

We can go with announcing in Tech News, with an end date (@Jdlrobson, it is up to you) and reasons why:

Starting [date], [https://www.mediawiki.org/wiki/Onboarding_new_Wikipedians#New_experience GettingStarted] will be removed from the wikis. This is due to the deployment of [https://www.mediawiki.org/wiki/Special:MyLanguage/Growth/Feature_summary Growth features], which provide a more complete experience for newcomers. [https://phabricator.wikimedia.org/T235752]

Happy to help with the Tech News entry. What date can we work towards realistically?

What date can we work towards realistically?

It is literally up to you, since this extension doesn't impacts others (AFACT).

Jdlrobson renamed this task from Deprecate/undeploy the GettingStarted extension to Undeploy the GettingStarted extension.Sep 13 2021, 5:55 PM

I'm going to bring this task up with the team next week, and perhaps we'll write the patch, and then know that we can deploy it at anytime. Then we'll pick a date and announce it.

MMiller_WMF raised the priority of this task from Lowest to High.Sep 21 2021, 2:18 AM

Change 722574 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Undeploy GettingStarted I: Disable on all wikis

https://gerrit.wikimedia.org/r/722574

Change 722575 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Undeploy GettingStarted II: Don't load regardless of config

https://gerrit.wikimedia.org/r/722575

Change 722576 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Undeploy getting started III: Don't set wmgUseGettingStarted, now ignored

https://gerrit.wikimedia.org/r/722576

Change 722578 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Undeploy GettingStarted V: Remove now-obsolete logging channels

https://gerrit.wikimedia.org/r/722578

A couple of post-undeployment tasks off the top of my head:

We can announce the date on the next Tech News. So we need a date. Let's say on week 40 (October 3)?

Possible text:

The GettingStarted extension provides an onboarding process for new editors of a few versions of Wikipedia. However, Growth features provide a more complete onboarding experience. Since the vast majority of Wikipedias now have access to the Growth features, GettingStarted will be deactivated on [date].

There's also gettingstarted-with-category-suggestions.yaml plus a couple wiki yaml files referencing it.

Parsoid which has a bunch of gettingstarted-task-toolbar-show-intro references in its codebase (which is a GettingStarted user preference key), not sure about that (tests? will they break when it's undeployed?) - @ssastry do you know about that?

Non-config followups:

Parsoid which has a bunch of gettingstarted-task-toolbar-show-intro references in its codebase (which is a GettingStarted user preference key), not sure about that (tests? will they break when it's undeployed?) - @ssastry do you know about that?

They are just cached site configs used in testing. We can regenerate them anytime.

We can announce the date on the next Tech News. So we need a date. Let's say on week 40 (October 3)?

Sounds good to me!

for Tech News, I see there are 2 drafts above. Which would you prefer?

Starting 4 October, [[GettingStarted]] will be removed from the wikis. This is due to the deployment of [[Growth features]], which provide a more complete experience for newcomers.

or

The [[GettingStarted extension]] provides an onboarding process for new editors of a few versions of Wikipedia. However, [[Growth features]] provide a more complete onboarding experience. Since the vast majority of Wikipedias now have access to the Growth features, GettingStarted will be deactivated starting on 4 October.

Urbanecm_WMF changed the subtype of this task from "Task" to "Deadline".

Set due date per T235752#7368815.

I pinged communities that have a page about the extension. I rely on Tech News for the others.

Change 722574 merged by jenkins-bot:

[operations/mediawiki-config@master] Undeploy GettingStarted I: Disable on all wikis

https://gerrit.wikimedia.org/r/722574

Change 722575 merged by jenkins-bot:

[operations/mediawiki-config@master] Undeploy GettingStarted II: Don't load regardless of config

https://gerrit.wikimedia.org/r/722575

Mentioned in SAL (#wikimedia-operations) [2021-10-04T11:35:10Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: 1c7405ad1eb323a8da524819f17d6f1a66afaa57: Undeploy GettingStarted I: Disable on all wikis (T235752) (duration: 00m 58s)

Change 722576 merged by jenkins-bot:

[operations/mediawiki-config@master] Undeploy getting started III: Don't set wmgUseGettingStarted, now ignored

https://gerrit.wikimedia.org/r/722576

Mentioned in SAL (#wikimedia-operations) [2021-10-04T11:37:00Z] <urbanecm@deploy1002> Synchronized wmf-config/CommonSettings.php: 9eaf960c4b7c304be57dfc8d248aca0c6501d04c: Undeploy GettingStarted II: Dont load regardless of config (T235752) (duration: 00m 58s)

@Trizek-WMF @MMiller_WMF This happened. Closing this directly, as there's really nothing to QA -- the extension is no longer executed (and it's practically not working for longer time). Not sure if a "done" notification should be sent too -- leaving that up to you.

Actually, needs few non-config followups too.

Mentioned in SAL (#wikimedia-operations) [2021-10-04T11:39:47Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: d60f332785868797e7ecc9b5e410616d5604b392: Undeploy getting started III: Dont set wmgUseGettingStarted, now ignored (T235752) (duration: 00m 58s)

Change 722577 had a related patch set uploaded (by Urbanecm; author: Urbanecm):

[operations/mediawiki-config@master] Undeploy GettingStarted IV: Don't build i18n

https://gerrit.wikimedia.org/r/722577

Change 722577 merged by jenkins-bot:

[operations/mediawiki-config@master] Undeploy GettingStarted IV: Don't build i18n

https://gerrit.wikimedia.org/r/722577

Mentioned in SAL (#wikimedia-operations) [2021-10-04T11:42:31Z] <urbanecm@deploy1002> Synchronized wmf-config/extension-list: 9709bcfc8dacbcd1704471df08c31cec0711bea6: Undeploy GettingStarted IV: Dont build i18n (T235752) (duration: 00m 58s)

Change 722578 merged by jenkins-bot:

[operations/mediawiki-config@master] Undeploy GettingStarted V: Remove now-obsolete logging channels

https://gerrit.wikimedia.org/r/722578

Hi @Kormat, pinging you as today's SRE clinic duty. The GettingStarted extension was undeployed, which means it no longer uses Redis in production (https://wikitech.wikimedia.org/wiki/Redis#Cluster_redis_sessions). I'm not sure if anything else needs to be done, apart from updating docs and undeploying the code.

Mentioned in SAL (#wikimedia-operations) [2021-10-04T11:44:29Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: b0a96bed4562bcc975187b1d34626201d407404b: Undeploy GettingStarted V: Remove now-obsolete logging channels (T235752) (duration: 00m 59s)

Hi @Kormat, pinging you as today's SRE clinic duty. The GettingStarted extension was undeployed, which means it no longer uses Redis in production (https://wikitech.wikimedia.org/wiki/Redis#Cluster_redis_sessions). I'm not sure if anything else needs to be done, apart from updating docs and undeploying the code.

As far as i can tell, this doesn't require anything from the SRE side of things. Cheers.

Change 725928 had a related patch set uploaded (by Raimond Spekking; author: Raimond Spekking):

[translatewiki@master] [GettingStarted] was undeployed from WMF cluster

https://gerrit.wikimedia.org/r/725928

Marked as unmaintained in https://www.mediawiki.org/w/index.php?title=Extension:GettingStarted&oldid=4851506, not sure if any other updates are warranted for that page.

Change 725910 had a related patch set uploaded (by Phuedx; author: Phuedx):

[mediawiki/extensions/GettingStarted@master] Revert \"Suppress VisualEditor welcome dialog when tour is active\"

https://gerrit.wikimedia.org/r/725910

Change 725928 merged by jenkins-bot:

[translatewiki@master] [GettingStarted] was undeployed from WMF cluster

https://gerrit.wikimedia.org/r/725928

Non-config followups:

  • drop the GettingStartedRedirectImpression EventLogging schema

I marked the schema as inactive in https://meta.wikimedia.org/w/index.php?title=Schema_talk%3AGettingStartedRedirectImpression&type=revision&diff=22118965&oldid=13302817.

Should dropping the data be tracked in another task?

Change 725980 had a related patch set uploaded (by Jforrester; author: Jforrester):

[mediawiki/tools/release@master] Stop branching GettingStarted for Wikimedia production

https://gerrit.wikimedia.org/r/725980

Change 725980 merged by jenkins-bot:

[mediawiki/tools/release@master] Stop branching GettingStarted for Wikimedia production

https://gerrit.wikimedia.org/r/725980

Change 726743 had a related patch set uploaded (by Gergő Tisza; author: Gergő Tisza):

[operations/mediawiki-config@master] Delete gettingstarted-with-category-suggestions dblist

https://gerrit.wikimedia.org/r/726743

Non-config followups:

  • drop the GettingStartedRedirectImpression EventLogging schema

I marked the schema as inactive in https://meta.wikimedia.org/w/index.php?title=Schema_talk%3AGettingStartedRedirectImpression&type=revision&diff=22118965&oldid=13302817.

Should dropping the data be tracked in another task?

@Ottomata, do you know if there are any conventions for the schemas of extensions which are undeployed? Should the schemas get dropped or preserved for the sake of history? Should we do something about the data or is it dropped eventually anyway? (It has a bunch of "keep" entries in event_sanitized_analytics_allowlist, not sure what that means for data retention.)

Change 726744 had a related patch set uploaded (by Gergő Tisza; author: Gergő Tisza):

[mediawiki/extensions/WikimediaMessages@master] Remove GettingStarted overrides

https://gerrit.wikimedia.org/r/726744

Change 726744 merged by jenkins-bot:

[mediawiki/extensions/WikimediaMessages@master] Remove GettingStarted overrides

https://gerrit.wikimedia.org/r/726744

Change 726743 merged by jenkins-bot:

[operations/mediawiki-config@master] Delete gettingstarted-with-category-suggestions dblist

https://gerrit.wikimedia.org/r/726743

Mentioned in SAL (#wikimedia-operations) [2021-10-06T10:01:51Z] <urbanecm@deploy1002> Synchronized dblists/: 01633739462f3bf09ae4e50b955454921ea4fbf9: Delete gettingstarted-with-category-suggestions dblist (T235752; 1/2) (duration: 01m 04s)

Mentioned in SAL (#wikimedia-operations) [2021-10-06T10:04:21Z] <urbanecm@deploy1002> Synchronized wmf-config/: 01633739462f3bf09ae4e50b955454921ea4fbf9: Delete gettingstarted-with-category-suggestions dblist (T235752; 2/2) (duration: 01m 05s)

dblist dropped from prod. Thanks a lot to everyone for helping with identifying things that should be cleaned up.

Change 725910 abandoned by Phuedx:

[mediawiki/extensions/GettingStarted@master] Revert \"Suppress VisualEditor welcome dialog when tour is active\"

Reason:

Per https://gerrit.wikimedia.org/r/c/mediawiki/extensions/GettingStarted/+/725910/1#message-fd1e76fdb256eebe41e343ba377cc315cd04807e.

https://gerrit.wikimedia.org/r/725910